﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module
'v1.00
Sub Class_Globals
	Private fe = 500000, ok = 0.9996, deg2rad = cPI / 180, rad2deg = 1 / deg2rad As Double
	Type LatLon (Lat As Double, Lon As Double)
	Type UTM (UtmXZone As Int, X As Double, NorthHemisphere As Boolean, Y As Double, Banda As String)
	Type UTMED50 (UtmXZoneED50 As Int, XED50 As Double, NorthHemisphereED50 As Boolean, YED50 As Double, Banda As String)
    Dim ArrayBandas() As Char
	ArrayBandas = Array As Char ("C", "D", "E", "F", "G", "H", "J", "K", "L", "M", "N", "P", "Q", "R", "S", "T", "U", "V", "W", "X") 'endutmtolatlon

	Dim aa As Double
	Dim BB As Double
	Dim SemiejeMayor(2) As Double
	Dim SemiejeMenor(2) As Double
    SemiejeMayor(0) = 6378137
    SemiejeMenor(0) = 6356752.314140
    SemiejeMayor(1) = 6378388 
	SemiejeMenor(1) = 6356911.946130

	Dim Modo As Double
	Dim Excentricidad1 As Double
	Dim Excentricidad2 As Double
	Dim CuadradoExcentricidad2 As Double
	Dim c As Double
	Dim MeriadianoHuso As Double
	Dim GradosDecimalesLongitud As Double
	Dim GradosDecimalesLatitud As Double
	Dim ConvertirLatitudPunto As String
	Dim ConvertirLongitudPunto As String
	Dim CoordLat As Double
	Dim CoordLong As Double
	Public CoordenadasGeocentricasLatitud As String
	Public CoordenadasGeocentricasLongitud As String
	Public CoordenadasGeocentricasLatitudGoogle As String
	Public CoordenadasGeocentricasLongitudGoogle As String
	Dim AO As Double	 	 'H es la Altitud Ortométrica
	Dim AE As Double 	 	 'h es la Altitud Elipsoidal
	Dim OG = 718.5 As Double 'N es la Ondulación del Geoide
    Dim LongitudGrados As Double
    Dim LongitudMinutos As Double
    Dim LongitudSegundos As Double
    Dim LatitudGrados As Double
    Dim LatitudMinutos As Double
    Dim LatitudSegundos As Double
	Dim RadianesLongitud As Double
	Dim RadianesLatitud As Double
	Dim Huso As Double
	Dim DeltaLambda As Double
	Dim Aplanamiento As Double
	Dim RtBanda As String

End Sub

Public Sub Initialize

End Sub

Private Sub CalculateESquared(a As Double, b As Double) As Double
    Return ((a * a) - (b * b)) / (a * a)
End Sub

Private Sub CalculateE2Squared(a As Double, b As Double) As Double
	Return ((a * a) - (b * b)) / (b * b)
End Sub

Private Sub denom(es As Double,  sphi As Double) As Double
	Dim sinSphi As Double
	sinSphi = Sin(sphi)
	Return Sqrt(1.0 - es * (sinSphi * sinSphi))
End Sub

Private Sub sphsr( a As Double,  es As Double,  sphi As Double) As Double
	Dim dn As Double
	dn = denom(es, sphi)
	Return a * (1.0 - es) / (dn * dn * dn)
End Sub

Private Sub sphsn( a As Double,  es As Double,  sphi As Double) As Double
    Dim sinSphi As Double
    sinSphi = Sin(sphi)
    Return a / Sqrt(1.0 - es * (sinSphi * sinSphi))
End Sub

Private Sub sphtmd( ap As Double,  bp As Double,  cp As Double,  dp As Double,  ep As Double, _
 sphi As Double) As Double
   Return  (ap * sphi) - (bp * Sin(2.0 * sphi)) + (cp * Sin(4.0 * sphi)) _
        - (dp * Sin(6.0 * sphi)) + (ep * Sin(8.0 * sphi))

End Sub

'-----------------------------------------------------------------------------------
'Convertir DATUM ETRS89/WGS84 a DATUM ED50
Public Sub WGS84aED50(u As UTM) As UTMED50
    Return UTMWGS84aUTMED50(u)
End Sub
'-----------------------------------------------------------------------------------

'Convert LatLon to UTM using WGS84 datum
Public Sub WGS84LatLonToUTM(LL As LatLon) As UTM
    Return LatLonToUTM(6378137, 0.003352810665, LL)
End Sub

'Convert UTM to LatLon using WGS84 datum
Public Sub WGS84UTMTOLatLon(U As UTM) As LatLon
    Return UTMToLatLon(6378137, 0.003352810665, U)
End Sub

Private Sub Fix(d As Double) As Int
	Return d
End Sub

'Convert LatLon to UTM.
'a - Equatorial radius
'f - aplastamiento
Private Sub LatLonToUTM(a As Double,  f As Double,  LL As LatLon) As UTM
    Dim recf As Double
    Dim b As Double
    Dim eSquared As Double
    Dim e2Squared As Double
    Dim tn As Double
    Dim ap As Double
    Dim bp As Double
    Dim cp As Double
    Dim dp As Double
    Dim ep As Double
    Dim olam As Double
    Dim dlam As Double
    Dim s As Double
    Dim c As Double
    Dim t As Double
    Dim eta As Double
    Dim sn As Double
    Dim tmd As Double
    Dim t1 As Double
    Dim t2 As Double
    Dim t3 As Double
    Dim t6 As Double
    Dim t7 As Double
    Dim nfn As Double
	Dim Lat = LL.Lat, Lon = LL.Lon As Double
    Dim easting, northing, utmXZone As Double
'	Dim RtBanda As String
	
    If (Lon <= 0) Then
        utmXZone = 30 + Fix(Lon / 6)
    Else
        utmXZone = 31 + Fix(Lon / 6)
    End If
	
'	FutmYzone(Lat)
	
	Dim res As UTM
	res.Initialize
    res.NorthHemisphere = Lat >= 0
    Dim latRad As Double
    latRad = Lat * deg2rad
    Dim lonRad As Double
    lonRad = Lon * deg2rad
    recf = 1 / f
    b = a * (recf - 1.0) / recf
    eSquared = CalculateESquared(a, b)
    e2Squared = CalculateE2Squared(a, b)
    tn = (a - b) / (a + b)
    ap = a * (1.0 - tn + 5.0 * ((tn * tn) - (tn * tn * tn)) / 4.0 + 81.0 * _
        ((tn * tn * tn * tn) - (tn * tn * tn * tn * tn)) / 64.0)
    bp = 3.0 * a * (tn - (tn * tn) + 7.0 * ((tn * tn * tn) _
        - (tn * tn * tn * tn)) / 8.0 + 55.0 * (tn * tn * tn * tn * tn) / 64.0) _
        / 2.0
    cp = 15.0 * a * ((tn * tn) - (tn * tn * tn) + 3.0 * ((tn * tn * tn * tn) _
        - (tn * tn * tn * tn * tn)) / 4.0) / 16.0
    dp = 35.0 * a * ((tn * tn * tn) - (tn * tn * tn * tn) + 11.0 _
        * (tn * tn * tn * tn * tn) / 16.0) / 48.0
    ep = 315.0 * a * ((tn * tn * tn * tn) - (tn * tn * tn * tn * tn)) / 512.0
    olam = (utmXZone * 6 - 183) * deg2rad
    dlam = lonRad - olam
    s = Sin(latRad)
    c = Cos(latRad)
    t = s / c
    eta = e2Squared * (c * c)
    sn = sphsn(a, eSquared, latRad)
    tmd = sphtmd(ap, bp, cp, dp, ep, latRad)
    t1 = tmd * ok
    t2 = sn * s * c * ok / 2.0
    t3 = sn * s * (c * c * c) * ok * (5.0 - (t * t) + 9.0 * eta + 4.0 _
        * (eta * eta)) / 24.0
    If (latRad < 0.0) Then nfn = 10000000.0 Else nfn = 0
    northing = nfn + t1 + (dlam * dlam) * t2 + (dlam * dlam * dlam _
        * dlam) * t3 + (dlam * dlam * dlam * dlam * dlam * dlam)
    t6 = sn * c * ok
    t7 = sn * (c * c * c) * (1.0 - (t * t) + eta) / 6.0
    easting = fe + dlam * t6 + (dlam * dlam * dlam) * t7
    If (northing >= 9999999.0) Then northing = 9999999.0
	
	res.X = easting
	res.Y = northing
	res.utmXZone = utmXZone
	res.Banda=RtBanda
	Return res
End Sub

'Convert UTM to LatLon
'a - Equatorial radius
'f - Flattening
Private Sub UTMToLatLon( a As Double,  f As Double, U As UTM) As LatLon

    Dim recf As Double
    Dim b As Double
    Dim eSquared As Double
    Dim e2Squared As Double
    Dim tn As Double
    Dim ap As Double
    Dim bp As Double
    Dim cp As Double
    Dim dp As Double
    Dim ep As Double
    Dim olam As Double
    Dim nfn As Double
    Dim tmd As Double
    Dim sr As Double
    Dim sn As Double
    Dim ftphi As Double
    Dim s As Double
    Dim c As Double
    Dim t As Double
    Dim eta As Double
    Dim de As Double
    Dim dlam As Double
    Dim lat, lon As Double
    recf = 1.0 / f
    b = a * (recf - 1) / recf
    eSquared = CalculateESquared(a, b)
    e2Squared = CalculateE2Squared(a, b)
    tn = (a - b) / (a + b)
    ap = a * (1.0 - tn + 5.0 * ((tn * tn) - (tn * tn * tn)) / 4.0 + 81.0 * _
        ((tn * tn * tn * tn) - (tn * tn * tn * tn * tn)) / 64.0)
    bp = 3.0 * a * (tn - (tn * tn) + 7.0 * ((tn * tn * tn) _
        - (tn * tn * tn * tn)) / 8.0 + 55.0 * (tn * tn * tn * tn * tn) / 64.0) _
        / 2.0
    cp = 15.0 * a * ((tn * tn) - (tn * tn * tn) + 3.0 * ((tn * tn * tn * tn) _
        - (tn * tn * tn * tn * tn)) / 4.0) / 16.0
    dp = 35.0 * a * ((tn * tn * tn) - (tn * tn * tn * tn) + 11.0 _
        * (tn * tn * tn * tn * tn) / 16.0) / 48.0
    ep = 315.0 * a * ((tn * tn * tn * tn) - (tn * tn * tn * tn * tn)) / 512.0
    If Not (U.NorthHemisphere) Then
        nfn = 10000000.0
    Else
        nfn = 0
    End If
    tmd = (U.Y - nfn) / ok
    sr = sphsr(a, eSquared, 0.0)
    ftphi = tmd / sr
    Dim t10 As Double, t11 As Double, t14 As Double, t15 As Double
    Dim Index As Int
    For Index = 0 To 4
        t10 = sphtmd(ap, bp, cp, dp, ep, ftphi)
        sr = sphsr(a, eSquared, ftphi)
        ftphi = ftphi + (tmd - t10) / sr
    Next
    sr = sphsr(a, eSquared, ftphi)
    sn = sphsn(a, eSquared, ftphi)
    s = Sin(ftphi)
    c = Cos(ftphi)
    t = s / c
    eta = e2Squared * (c * c)
    de = U.X - fe
    t10 = t / (2.0 * sr * sn * (ok * ok))
    t11 = t * (5.0 + 3.0 * (t * t) + eta - 4.0 * (eta * eta) - 9.0 * (t * t) _
        * eta) / (24.0 * sr * (sn * sn * sn) * (ok * ok * ok * ok))
    lat = ftphi - (de * de) * t10 + (de * de * de * de) * t11
    t14 = 1.0 / (sn * c * ok)
    t15 = (1.0 + 2.0 * (t * t) + eta) / (6 * (sn * sn * sn) * c _
        * (ok * ok * ok))
    dlam = de * t14 - (de * de * de) * t15
    olam = (U.UtmXZone * 6 - 183.0) * deg2rad
    lon = olam + dlam
    lon = lon * rad2deg
    lat = lat * rad2deg
	Dim ll As LatLon
	ll.Initialize
	ll.lat = lat
	ll.lon = lon
    Return ll
End Sub

'Public Sub Change(LL As LatLon) As UTM
'    Return ChangeDatum(LL,6378137, 0.003352810665,6399936.608, 0.003367003,435161,4815366,100)
'End Sub

	
	
'Public Sub ChangeDatum( LL As LatLon, _
' 	From_a As Double,  From_f As Double,  To_a As Double,  To_f As Double, _
' 	dx As Double,  dy As Double,  dz As Double) As LatLon
'	Dim lat = LL.lat, lon = LL.lon As Double
'    lat = lat / 180 * cPI
'    lon = lon / 180 * cPI
'    Dim slat As Double = Sin(lat)
'    Dim clat As Double = Cos(lat)
'    Dim slon As Double = Sin(lon)
'    Dim clon As Double = Cos(lon)
'    Dim ssqlat As Double = slat * slat
'    Dim adb As Double = 1.0 / (1.0 - From_f) '  // "a divided by b"
'    Dim dlat, dlon As Double
'    Dim from_esq As Double = 2 * From_f - Power(From_f, 2)
'    Dim rn As Double = From_a / Sqrt(1.0 - from_esq * ssqlat)
'    Dim rm As Double = From_a * (1.0 - from_esq) / Power((1.0 - from_esq * ssqlat), 1.5)
'    Dim res As LatLon
'    Dim da As Double = To_a - From_a
'    Dim df As Double = To_f - From_f
'    dlat = (((((-dx * slat * clon - dy * slat * slon) + dz * clat) _
'                + (da * ((rn * from_esq * slat * clat) / From_a))) _
'            + (df * (rm * adb + rn / adb) * slat * clat))) _
'        / (rm + 0)

'    dlon = (-dx * slon + dy * clon) / ((rn + 0) * clat)

'  	res.Initialize
'    res.lat = lat + dlat
'    res.lon = lon + dlon
'    res.lat = res.lat / cPI * 180
'   res.lon = res.lon / cPI * 180
'    Return res
'End Sub


Private Sub UTMWGS84aUTMED50(U As UTM ) As UTMED50
    'Convertir de ETRS89/WGS84 a ED50
    'Comprobado variables
    Dim Excentricidad2Cuadrado As Double
    Dim x As Double
    Dim y As Double
    Dim omega As Double
    Dim Ni As Double
    Dim fi As Double
    Dim A1 As Double
    Dim A2 As Double
    Dim J2 As Double
    Dim J4 As Double
    Dim J6 As Double
    Dim alfa As Double
    Dim beta As Double
    Dim gamma As Double
    Dim B2 As Double
    Dim B3 As Double
    Dim Zeta As Double
    Dim Xi As Double
    Dim Eta As Double
    Dim senoh As Double
    Dim lambda As Double
    Dim Tau As Double
    Dim Longitud As Double
    Dim Latitud As Double
    Dim n As Double
    Dim CuadradoSemiejeMayor As Double
    Dim CuadradoSemiejeMenor As Double
    Dim Coseno As Double
    Dim Seno As Double
    Dim CoordCartesaniasX As Double
    Dim CoordCartesaniasY As Double
    Dim CoordCartesaniasZ As Double
    Dim DatumX As Double
    Dim DatumY As Double
    Dim DatumZ As Double
    Dim Excentricidad2Cuadrado2 As Double
    Dim theta As Double
    Dim si As Double
    Dim hh As Double
    Dim ValtxtDecimalesLat As Double
    Dim ValtxtDecimalesLon As Double
    Dim CosenoCuadrado As Double
	Dim Lat = U.y, Lon = U.x As Double
    Dim easting, northing, utmZona As Double
 
	Dim resED50 As UTMED50
	resED50.Initialize
    resED50.NorthHemisphereED50 = Lat >= 0
    utmZona=U.UtmXZone
    Modo = 0
    CargarDatos(Modo)
    
    'TratamientoETRS89/WGS84
    Excentricidad2Cuadrado = CuadradoExcentricidad2
    x =Fix(Lon)
    y =Fix(Lat)
    x = x - 500000
    If (U.NorthHemisphere) Then
		y = y
    Else
         y = y - 10000000
    End If
    MeriadianoHuso = utmZona * 6 - 183
    fi = (y) / (6366197.724 * 0.9996)
    Ni = (c / Power ((1 + Excentricidad2Cuadrado * Cos(fi) * Cos(fi)) , 0.5)) * 0.9996
    omega = x / Ni
    A1 = Sin(2 * fi)
    A2 =A1 * Cos(fi) * Cos(fi) ' ^ 2
    J2 = fi + (A1 / 2)
    J4 = (3 * J2 + A2) / 4
    J6 = (5 * J4 + A2 * Cos(fi) * Cos(fi)) / 3
    alfa = (3 / 4) * Excentricidad2Cuadrado
    beta = (5 / 3) * (alfa) * (alfa)'^ 2
    gamma = (35 / 27) * (alfa) * (alfa)* (alfa)'^ 3
    B2 = 0.9996 * c * (fi - (alfa * J2) + (beta * J4) - (gamma * J6))
    B3 = (y - B2) / Ni
    Zeta = ((Excentricidad2Cuadrado * omega * omega) / 2) * (Cos(fi))  * (Cos(fi))'^ 2
    Xi = omega * (1 - (Zeta / 3))
    Eta = B3 * (1 - Zeta) + fi
    senoh = (Power(2.71828182845905 , Xi) - Power(2.71828182845905 , - Xi)) / 2
    lambda = ATan(senoh / Cos(Eta))
    Tau = ATan(Cos(lambda) * Tan(Eta))
    
    'Longitud en ETRS89
    Longitud = lambda / cPI * 180 + MeriadianoHuso
    GradosDecimalesLongitud = Longitud
    ConvertirLongitudPunto = Longitud
    
    'Latitud en ETRS89
    Latitud = fi + (1 + Excentricidad2Cuadrado * (Cos(fi)) * (Cos(fi)) - (3 / 2) * Excentricidad2Cuadrado * Sin(fi) * Cos(fi) * (Tau - fi)) * (Tau - fi)
    GradosDecimalesLatitud = Latitud / cPI * 180
    ConvertirLatitudPunto = GradosDecimalesLatitud
    '----------------------------------
   	Modo = 0
    CargarDatos (Modo)
    CoordenadasGeocentricasLongitud = Longitud
    LongitudGrados = Fix(Longitud)
    LongitudMinutos = Fix((Longitud - LongitudGrados) * 60)
    LongitudSegundos = (((Longitud - LongitudGrados) * 60) - LongitudMinutos) * 60
    'Latitud
    CoordenadasGeocentricasLatitud = GradosDecimalesLatitud
    LatitudGrados = Fix(GradosDecimalesLatitud)
    LatitudMinutos = Fix((GradosDecimalesLatitud - LatitudGrados) * 60)
    LatitudSegundos = (((GradosDecimalesLatitud - LatitudGrados) * 60) - LatitudMinutos) * 60
    CoordLat = (CoordenadasGeocentricasLatitud)
    CoordLong = (CoordenadasGeocentricasLongitud)
    CuadradoSemiejeMayor = SemiejeMayor(0) * SemiejeMayor(0)
    CuadradoSemiejeMenor = SemiejeMenor(0) * SemiejeMenor(0)
    Coseno = (Cos(CoordLat * cPI / 180)) * (Cos(CoordLat * cPI / 180))
    Seno = (Sin(CoordLat * cPI / 180)) * (Sin(CoordLat * cPI / 180))
    ' Radio de curvatura en la vertical principal del punto
    n = (CuadradoSemiejeMayor / Sqrt((CuadradoSemiejeMayor * Coseno) + (CuadradoSemiejeMenor * Seno)))
    AE = OG + 0
    ' Obtener la X, Y, Z cartesianas geocéntricas (ECEF):
    CoordCartesaniasX = (n + AE) * Cos(CoordLat * cPI / 180) * Cos(CoordLong * cPI / 180)
    CoordCartesaniasY = (n + AE) * Cos(CoordLat * cPI / 180) * Sin(CoordLong * cPI / 180)
    CoordCartesaniasZ = ((CuadradoSemiejeMenor / CuadradoSemiejeMayor) * n + AE) * Sin(CoordLat * cPI / 180)
    ' Procedemos a resolver el cambio de datum:
    DatumX = 131.032 + (1 + (-0.00000939)) * (1 * CoordCartesaniasX + (-0.0000055443 * CoordCartesaniasY) - (-0.0000000945 * CoordCartesaniasZ))
    DatumY = 100.251 + (1 + (-0.00000939)) * (0.0000055443 * CoordCartesaniasX + 1 * (CoordCartesaniasY) + (-0.0000060301 * CoordCartesaniasZ))
    DatumZ = 163.354 + (1 + (-0.00000939)) * (-0.0000000945 * CoordCartesaniasX - (-0.0000060301 * (CoordCartesaniasY)) + 1 * CoordCartesaniasZ)
    CuadradoSemiejeMayor = SemiejeMayor(1) * SemiejeMayor(1)
    CuadradoSemiejeMenor = SemiejeMenor(1) * SemiejeMenor(1)
    ' Cálculo de la excentricidad al cuadrado y la segunda excentricidad al cuadarado, tenemos
    Excentricidad2Cuadrado = (CuadradoSemiejeMayor - CuadradoSemiejeMenor) / CuadradoSemiejeMayor
    Excentricidad2Cuadrado2 = (CuadradoSemiejeMayor - CuadradoSemiejeMenor) / CuadradoSemiejeMenor
    ' Calcular los dos valores auxiliares p y q:
    fi = Sqrt((DatumX * DatumX) + (DatumY * DatumY))
    theta = ATan((DatumZ * SemiejeMayor(1)) / (fi * SemiejeMenor(1)))
    ' Calcular la latitud geodésica (j), la longitud geodésica (l),
    si = ATan((DatumZ + Excentricidad2Cuadrado2 * SemiejeMenor(1) * Sin(theta) * Sin(theta) * Sin(theta)) / (fi - Excentricidad2Cuadrado * SemiejeMayor(1) * Cos(theta) * Cos(theta) * Cos(theta)))
    lambda = ATan(DatumY / DatumX)
    ' Calcular el valor de N:
    n = CuadradoSemiejeMayor / Sqrt((CuadradoSemiejeMayor * Cos(si) * Cos(si)) + (CuadradoSemiejeMenor * Sin(si) * Sin(si)))
    ' Altitud geodésica(AE):
    hh = (fi / Cos(si)) - n
    ' Obtener grados sexagesimales
    si = si * (180 / cPI)
    lambda = lambda * (180 / cPI)
    lambda=lambda * -1
	'Longitud
    LongitudGrados = Fix(lambda)
    LongitudMinutos = Fix((lambda - LongitudGrados) * 60)
    LongitudSegundos = ((((lambda - LongitudGrados) * 60) - LongitudMinutos) * 60)
'    'Latitud
    LatitudGrados = Fix(si)
    LatitudMinutos = Fix((si - LatitudGrados) * 60)
    LatitudSegundos = (((si - LatitudGrados) * 60) - LatitudMinutos) * 60
    GradosDecimalesLongitud = (LongitudGrados) + (((LongitudMinutos)) / 60) + (((LongitudSegundos)) / 60 / 60)
    GradosDecimalesLatitud = (LatitudGrados) + (((LatitudMinutos)) / 60) + (((LatitudSegundos)) / 60 / 60)
    CoordenadasGeocentricasLatitud = GradosDecimalesLatitud' * ConstanteDesplazamientoAltitud
    CoordenadasGeocentricasLongitud = GradosDecimalesLongitud * -1' ConstanteDesplazamientoLongitud
	Modo = 1
    CargarDatos(Modo)
'   LongitudLatitud
    ValtxtDecimalesLat = (CoordenadasGeocentricasLatitud) 'txtDecimalesLat.Text)
    ValtxtDecimalesLon = (CoordenadasGeocentricasLongitud) 'txtDecimalesLon.Text)
    RadianesLongitud = ValtxtDecimalesLon * cPI / 180
    RadianesLatitud = ValtxtDecimalesLat * cPI / 180
    Huso =Fix( (ValtxtDecimalesLon / 6) + 31)
	MeriadianoHuso = Huso * 6 - 183
    DeltaLambda = RadianesLongitud - (MeriadianoHuso * (cPI / 180))
'   CalculodeParametros
    Excentricidad2Cuadrado = CuadradoExcentricidad2
    aa = Cos(RadianesLatitud) * Sin(DeltaLambda)
    Xi = (1/2) * Logarithm((1 + aa) / (1 - aa), cE)
    Eta = ATan((Tan(RadianesLatitud)) / Cos(DeltaLambda)) - RadianesLatitud
    Ni = (c / Power ((1 + Excentricidad2Cuadrado * Cos(RadianesLatitud) * Cos(RadianesLatitud)) , 0.5)) * 0.9996
	Zeta = (Excentricidad2Cuadrado / 2) * Xi * Xi * Cos(RadianesLatitud) * Cos(RadianesLatitud)
    A1 = Sin(2 * RadianesLatitud)
    A2 = A1 * Cos(RadianesLatitud)* Cos(RadianesLatitud)
    J2 = RadianesLatitud + (A1 / 2)
    J4 = ((3 * J2) + A2) / 4
    J6 = (5 * J4 + A2 * (Cos(RadianesLatitud) * Cos(RadianesLatitud))) / 3
    alfa = (3 / 4) * Excentricidad2Cuadrado
    beta = (5 / 3) * alfa * alfa
    gamma = (35 / 27) * alfa * alfa * alfa
    B2 = 0.9996 * c * (RadianesLatitud - (alfa * J2) + (beta * J4) - (gamma * J6))
    x = Xi * Ni * (1 + Zeta / 3) + 500000
    If CoordenadasGeocentricasLatitud >= 0 Then
        y = Eta * Ni * (1 + Zeta) + B2
    Else
        y = Eta * Ni * (1 + Zeta) + B2 + 10000000
    End If
	ZonaBanda(CoordLat)
	resED50.XED50 = x
	resED50.YED50 = y
	resED50.UtmXZoneED50 =U.UtmXZone
	resED50.Banda=RtBanda
    Return resED50
End Sub

Private Sub CargarDatos(Num)
    aa = SemiejeMayor(Num)
    BB = SemiejeMenor(Num)
    Excentricidad1 = Sqrt((aa * aa) - (BB * BB)) / aa
    Excentricidad2 = Sqrt((aa * aa) - (BB * BB)) / BB
    CuadradoExcentricidad2 = Excentricidad2 * Excentricidad2
    c = (aa * aa) / BB
    Aplanamiento = (aa - BB) / aa
End Sub

Private Sub ZonaBanda(lat As Double) As Short
    Dim Letra As String
    If (lat < 84 AND lat >= 72) Then
        '// Caso especial: Zona X es de 12 grados de norte a sur, no 8.
        Letra = ArrayBandas(19)
    Else
        Letra = ArrayBandas(Fix((lat + 80) / 8))
    End If
    If (lat >= 84 OR lat < -80) Then
        '// Coordenadas no validas, deben de ser <= 84 o > -80
        Letra = "*"
    End If
	RtBanda = Letra
    Return
End Sub
